// ==UserScript==
// @name           nlw_character_count
// @namespace      kabeminT
// @description    ぬりかべの書き込み中の文字数をカウント
// @include        main
// @compatibility  Firefox 3.6 4.0
// @author         kabeminT
// @version        2011/05/03 20:30
// ==/UserScript==


(function () {

let font_size    = 11;	//カウンター文字サイズ(px)
let marginRight  = 2;	//位置(右から)
let marginBottom = 0;	//位置(下から)


let max_count    = 500;	//最大文字数(仮)

let inserted_nodes = [];
let check_timer = null;
let check_wait = 10;


//カウンター更新
function counter_update (){//{{{
	let counterDiv = content.document.getElementById('nlwCommentCharCounter');
	let textarea = content.document.getElementById('nlwResponseTextarea');
	if(!counterDiv || !textarea)
		return;

	let num = textarea.value.length;
	//改行文字は1つで11文字扱い
	num += (textarea.value.split('\n').length-1) * 10;
	num += (textarea.value.split('|').length-1) * 10;
	if(num==0){
		counterDiv.style.display = "none";
	}
	else if(num > max_count){
		counterDiv.style.display = "block";
		counterDiv.style.color = "red";
	}
	else{
		counterDiv.style.display = "block";
		counterDiv.style.color = "white";
	}
	counterDiv.innerHTML = num + "/" + max_count;
}//}}}

//カウンターをセット
function counter_set (){//{{{
	// キー押し上げ時にカウンターを更新させる
	let textarea = content.document.getElementById("nlwResponseTextarea");
	textarea.addEventListener("keyup", counter_update, false);

	// カウンター表示部分
	let counterDiv = content.document.createElement("div");
	counterDiv.id = "nlwCommentCharCounter";
	counterDiv.style.position = "absolute";
	counterDiv.style.display = "block";
	counterDiv.style.backgroundColor = "black";
	counterDiv.style.fontSize = font_size;
	counterDiv.style.textAlign = "right";
	//counterDiv.style.zIndex = "2147483647";
	counterDiv.style.right   = 0;
	counterDiv.style.bottom  = 0;
	counterDiv.style.marginRight  = marginRight;
	counterDiv.style.marginBottom = marginBottom;
	counterDiv.style.padding = "1px";
	counterDiv.style.width  = font_size*5+"px";
	counterDiv.style.height = font_size+2+"px";
	counterDiv.style.opacity = 0.7;

	content.document.getElementById('nlwPartsDiv').appendChild(counterDiv);

	counter_update();
}//}}}

//書き込み用テキストエリアを探す
function func_inserted (e){//{{{
	//とりあえず要素を積んでおいて
	inserted_nodes.push(e.target);

	//少し待ってから(check_wait)まとめて処理
	if(!check_timer){
		check_timer = setTimeout(function(){

			for(let i=0; i<inserted_nodes.length; i++){
				// 書き込みエリアが現れた!!
				if(inserted_nodes[i].id=="nlwResponseTextarea"){
					content.document.removeEventListener("DOMNodeInserted", func_inserted, false);
					counter_set();
				}
			}

			inserted_nodes = [];
			check_timer = null;
		}, check_wait);
	}
}//}}}


gBrowser.addEventListener('DOMContentLoaded', function(){
	content.document.addEventListener("DOMNodeInserted", func_inserted, false);
}, false);


})();


// vim: set tabstop=4 shiftwidth=4 softtabstop=4 fdm=marker :
